Index: /LMDZ4/trunk/libf/phylmd/physiq.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 1403)
@@ -41,4 +41,6 @@
       use conf_phys_m, only: conf_phys
       use radlwsw_m, only: radlwsw
+      USE control_mod
+
 
       IMPLICIT none
@@ -99,5 +101,4 @@
 #include "dimsoil.h"
 #include "clesphys.h"
-#include "control.h"
 #include "temps.h"
 #include "iniprint.h"
@@ -216,4 +217,6 @@
       REAL d_ps(klon)
       real da(klon,klev),phi(klon,klev,klev),mp(klon,klev)
+!IM definition dynamique o_trac dans phys_output_open
+!      type(ctrl_out) :: o_trac(nqtot)
 c
 cIM Amip2 PV a theta constante 
@@ -258,5 +261,5 @@
       CHARACTER*4 bb2
       CHARACTER*2 bb3
-c 
+
       real twriteSTD(klon,nlevSTD,nfiles)
       real qwriteSTD(klon,nlevSTD,nfiles)
@@ -473,5 +476,5 @@
 c
 c cnameisccp
-      CHARACTER *27 cnameisccp(lmaxm1,kmaxm1)
+      CHARACTER *29 cnameisccp(lmaxm1,kmaxm1)
 cIM bad 151205     DATA cnameisccp/'pc< 50hPa, tau< 0.3', 
       DATA cnameisccp/'pc= 50-180hPa, tau< 0.3',
@@ -639,5 +642,6 @@
       REAL q_undi(klon,klev)               ! humidite moyenne dans la zone non perturbee
 c
-      REAL wake_pe(klon)              ! Wake potential energy - WAPE 
+cjyg
+ccc      REAL wake_pe(klon)              ! Wake potential energy - WAPE 
 
       REAL wake_gfl(klon)             ! Gust Front Length
@@ -655,4 +659,7 @@
       REAL dt_a(klon,klev)
       REAL dq_a(klon,klev)
+      REAL, SAVE :: alp_offset
+c$OMP THREADPRIVATE(alp_offset)
+
 c
 cRR:fin declarations poches froides
@@ -660,5 +667,9 @@
 
       REAL zw2(klon,klev+1)
-      REAL fraca(klon,klev+1)
+      REAL fraca(klon,klev+1)        
+      REAL ztv(klon,klev) 
+      REAL zpspsk(klon,klev)
+      REAL ztla(klon,klev) 
+      REAL zthl(klon,klev)
 
 c Variables locales pour la couche limite (al1):
@@ -1217,5 +1228,6 @@
      .     iflag_thermals_ed,iflag_thermals_optflux,
 c     nv flags pour la convection et les poches froides
-     .     iflag_coupl,iflag_clos,iflag_wake, read_climoz)
+     .     iflag_coupl,iflag_clos,iflag_wake, read_climoz,
+     &     alp_offset)
       call phys_state_var_init(read_climoz)
       call phys_output_var_init
@@ -1239,6 +1251,7 @@
 c         pmflxr=0.
 c         pmflxs=0.
-          itau_con=0
-	first=.false.
+
+        itau_con=0
+        first=.false.
 
       endif  ! first
@@ -1263,5 +1276,5 @@
 ! Gestion calendrier : mise a jour du module phys_cal_mod
 !
-cIM     CALL phys_cal_update(jD_cur,jH_cur)
+c     CALL phys_cal_update(jD_cur,jH_cur)
 
 c
@@ -1386,5 +1399,5 @@
          ENDIF
 c
-         IF (dtime*FLOAT(radpas).GT.21600..AND.cycle_diurne) THEN 
+         IF (dtime*REAL(radpas).GT.21600..AND.cycle_diurne) THEN 
            WRITE(lunout,*)'Nbre d appels au rayonnement insuffisant'
            WRITE(lunout,*)"Au minimum 4 appels par jour si cycle diurne"
@@ -1496,5 +1509,6 @@
      &                        type_ocean,iflag_pbl,ok_mensuel,ok_journe,
      &                        ok_hf,ok_instan,ok_LES,ok_ade,ok_aie, 
-     &                        read_climoz, new_aod, aerosol_couple)
+     &                        read_climoz, new_aod, aerosol_couple
+     &                        )
 c$OMP END MASTER
 c$OMP BARRIER
@@ -1558,6 +1572,6 @@
          CALL VTb(VTinca)
 !         iii = MOD(NINT(xjour),360)
-!         calday = FLOAT(iii) + jH_cur
-         calday = FLOAT(days_elapsed) + jH_cur
+!         calday = REAL(iii) + jH_cur
+         calday = REAL(days_elapsed) + jH_cur
          WRITE(lunout,*) 'initial time chemini', days_elapsed, calday
 
@@ -1841,5 +1855,5 @@
 !   solarlong0
         if (solarlong0<-999.) then
-           CALL orbite(FLOAT(days_elapsed+1),zlongi,dist)
+           CALL orbite(REAL(days_elapsed+1),zlongi,dist)
         else
            zlongi=solarlong0  ! longitude solaire vraie
@@ -1852,5 +1866,5 @@
 !  Avec ou sans cycle diurne
       IF (cycle_diurne) THEN
-        zdtime=dtime*FLOAT(radpas) ! pas de temps du rayonnement (s)
+        zdtime=dtime*REAL(radpas) ! pas de temps du rayonnement (s)
         CALL zenang(zlongi,jH_cur,zdtime,rlat,rlon,rmu0,fract)
       ELSE
@@ -1862,5 +1876,5 @@
         call writefield_phy('v_seri',v_seri,llm)
         call writefield_phy('t_seri',t_seri,llm)
-	call writefield_phy('q_seri',q_seri,llm)
+        call writefield_phy('q_seri',q_seri,llm)
       endif
 
@@ -1919,5 +1933,5 @@
         call writefield_phy('v_seri',v_seri,llm)
         call writefield_phy('t_seri',t_seri,llm)
-	call writefield_phy('q_seri',q_seri,llm)
+        call writefield_phy('q_seri',q_seri,llm)
       endif
 
@@ -2001,5 +2015,6 @@
 
       IF (iflag_con.EQ.1) THEN
-          stop'reactiver le call conlmd dans physiq.F'
+        abort_message ='reactiver le call conlmd dans physiq.F'
+        CALL abort_gcm (modname,abort_message,1)
 c     CALL conlmd (dtime, paprs, pplay, t_seri, q_seri, conv_q,
 c    .             d_t_con, d_q_con,
@@ -2059,17 +2074,29 @@
 c
 ccalcul de ale_wake et alp_wake
-       do i = 1,klon
-          if (iflag_wake.eq.1) then
-          ale_wake(i) = 0.5*wake_cstar(i)**2
-          alp_wake(i) = wake_fip(i)
-          else
-          ale_wake(i) = 0.
-          alp_wake(i) = 0.
-          endif
-       enddo
+       if (iflag_wake.eq.1) then
+         if (itap .le. it_wape_prescr) then
+          do i = 1,klon
+           ale_wake(i) = wape_prescr
+           alp_wake(i) = fip_prescr
+          enddo
+         else
+          do i = 1,klon
+cjyg  ALE=WAPE au lieu de ALE = 1/2 Cstar**2
+ccc           ale_wake(i) = 0.5*wake_cstar(i)**2
+           ale_wake(i) = wake_pe(i)
+           alp_wake(i) = wake_fip(i)
+          enddo
+         endif
+       else
+         do i = 1,klon
+           ale_wake(i) = 0.
+           alp_wake(i) = 0.
+         enddo
+       endif
 ccombinaison avec ale et alp de couche limite: constantes si pas de couplage, valeurs calculees
 cdans le thermique sinon
        if (iflag_coupl.eq.0) then
-          if (debut) print*,'ALE et ALP imposes'
+          if (debut.and.prt_level.gt.9)
+     $                     WRITE(lunout,*)'ALE et ALP imposes'
           do i = 1,klon
 con ne couple que ale
@@ -2082,10 +2109,31 @@
        else
          IF(prt_level>9)WRITE(lunout,*)'ALE et ALP couples au thermique'
-          do i = 1,klon
-              ALE(i) = max(ale_wake(i),Ale_bl(i))
-              ALP(i) = alp_wake(i) + Alp_bl(i)
-c         write(20,*)'ALE',ALE(i),Ale_bl(i),ale_wake(i)
-c         write(21,*)'ALP',ALP(i),Alp_bl(i),alp_wake(i)
-          enddo
+!         do i = 1,klon
+!             ALE(i) = max(ale_wake(i),Ale_bl(i))
+! avant        ALP(i) = alp_wake(i) + Alp_bl(i)
+!             ALP(i) = alp_wake(i) + Alp_bl(i) + alp_offset ! modif sb
+!         write(20,*)'ALE',ALE(i),Ale_bl(i),ale_wake(i)
+!         write(21,*)'ALP',ALP(i),Alp_bl(i),alp_wake(i)
+!         enddo
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! Modif FH 2010/04/27. Sans doute temporaire.
+! Deux options pour le alp_offset : constant si >Ã 0 ou proportionnel Ãa
+! w si <0
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+       do i = 1,klon
+          ALE(i) = max(ale_wake(i),Ale_bl(i))
+          if (alp_offset>=0.) then
+            ALP(i) = alp_wake(i) + Alp_bl(i) + alp_offset ! modif sb
+          else
+            ALP(i)=alp_wake(i)+Alp_bl(i)+alp_offset*min(omega(i,6),0.)
+            if (alp(i)<0.) then
+               print*,'ALP ',alp(i),alp_wake(i)
+     s         ,Alp_bl(i),alp_offset*min(omega(i,6),0.)
+            endif
+          endif
+       enddo
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
        endif
        do i=1,klon
@@ -2224,5 +2272,5 @@
         call writefield_phy('v_seri',v_seri,llm)
         call writefield_phy('t_seri',t_seri,llm)
-	call writefield_phy('q_seri',q_seri,llm)
+        call writefield_phy('q_seri',q_seri,llm)
       endif
 
@@ -2246,7 +2294,7 @@
           za = 0.0
           DO i = 1, klon
-            za = za + airephy(i)/FLOAT(klon)
+            za = za + airephy(i)/REAL(klon)
             zx_t = zx_t + (rain_con(i)+
-     .                   snow_con(i))*airephy(i)/FLOAT(klon)
+     .                   snow_con(i))*airephy(i)/REAL(klon)
           ENDDO
           zx_t = zx_t/za*dtime
@@ -2328,4 +2376,19 @@
 
       endif
+c
+c===================================================================
+cJYG
+      IF (ip_ebil_phy.ge.2) THEN 
+        ztit='after wake'
+        CALL diagetpq(airephy,ztit,ip_ebil_phy,2,2,dtime
+     e      , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay
+     s      , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
+        call diagphy(airephy,ztit,ip_ebil_phy
+     e      , zero_v, zero_v, zero_v, zero_v, zero_v
+     e      , zero_v, zero_v, zero_v, ztsol
+     e      , d_h_vcol, d_qt, d_ec
+     s      , fs_bound, fq_bound )
+      END IF 
+
 c      print*,'apres callwake iflag_cldcon=', iflag_cldcon
 c
@@ -2347,7 +2410,7 @@
       clwcon0th(:,:)=0.
 c
-      fm_therm(:,:)=0.
-      entr_therm(:,:)=0.
-      detr_therm(:,:)=0.
+c      fm_therm(:,:)=0.
+c      entr_therm(:,:)=0.
+c      detr_therm(:,:)=0.
 c
       IF(prt_level>9)WRITE(lunout,*)
@@ -2377,6 +2440,18 @@
      s      ,ratqsdiff,zqsatth
 con rajoute ale et alp, et les caracteristiques de la couche alim
-     s      ,Ale_bl,Alp_bl,lalim_conv,wght_th, zmax0, f0, zw2,fraca)
+     s      ,Ale_bl,Alp_bl,lalim_conv,wght_th, zmax0, f0, zw2,fraca
+     s      ,ztv,zpspsk,ztla,zthl)
+
+! ----------------------------------------------------------------------
+! Transport de la TKE par les panaches thermiques.
+! FH : 2010/02/01
+      if (iflag_pbl.eq.10) then
+      call thermcell_dtke(klon,klev,nbsrf,pdtphys,fm_therm,entr_therm,
+     s           rg,paprs,pbl_tke)
+      endif
+! ----------------------------------------------------------------------
+
          endif
+
 
 
@@ -2430,4 +2505,9 @@
      e      , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay
      s      , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
+        call diagphy(airephy,ztit,ip_ebil_phy
+     e      , zero_v, zero_v, zero_v, zero_v, zero_v
+     e      , zero_v, zero_v, zero_v, ztsol
+     e      , d_h_vcol, d_qt, d_ec
+     s      , fs_bound, fq_bound )
       END IF 
 
@@ -2478,5 +2558,7 @@
          enddo
          tau_overturning_th(:)=zmax_th(:)/max(0.5*wmax_th(:),0.1)
-         print*,'TAU TH OK ',tau_overturning_th(1),detr_therm(1,3)
+         if(prt_level.ge.9)
+     &     write(lunout,*)'TAU TH OK ',
+     &     tau_overturning_th(1),detr_therm(1,3)
 
 c On impose que l'air autour de la fraction couverte par le thermique
@@ -2589,5 +2671,6 @@
 
 !   les ratqs sont une combinaison de ratqss et ratqsc
-!       print*,'PHYLMD NOUVEAU TAU_RATQS ',tau_ratqs
+       if(prt_level.ge.9)
+     $       write(lunout,*)'PHYLMD NOUVEAU TAU_RATQS ',tau_ratqs
 
          if (tau_ratqs>1.e-10) then
@@ -2620,5 +2703,6 @@
      .           pfrac_impa, pfrac_nucl, pfrac_1nucl,
      .           frac_impa, frac_nucl,
-     .           prfl, psfl, rhcl)
+     .           prfl, psfl, rhcl, 
+     .           zqasc, fraca,ztv,zpspsk,ztla,zthl,iflag_cldcon )
 
       WHERE (rain_lsc < 0) rain_lsc = 0.
@@ -2640,7 +2724,7 @@
          za = 0.0
          DO i = 1, klon
-            za = za + airephy(i)/FLOAT(klon)
+            za = za + airephy(i)/REAL(klon)
             zx_t = zx_t + (rain_lsc(i)
-     .                  + snow_lsc(i))*airephy(i)/FLOAT(klon)
+     .                  + snow_lsc(i))*airephy(i)/REAL(klon)
         ENDDO
          zx_t = zx_t/za*dtime
@@ -2664,5 +2748,5 @@
         call writefield_phy('v_seri',v_seri,llm)
         call writefield_phy('t_seri',t_seri,llm)
-	call writefield_phy('q_seri',q_seri,llm)
+        call writefield_phy('q_seri',q_seri,llm)
       endif
 
@@ -2741,4 +2825,7 @@
      &        tausum_aero, tau3d_aero)
       ELSE
+cIM 170310 BEG
+         tausum_aero(:,:,:) = 0.
+cIM 170310 END
          tau_aero(:,:,:,:) = 0.
          piz_aero(:,:,:,:) = 0.
@@ -2813,4 +2900,9 @@
      e      , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay
      s      , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
+        call diagphy(airephy,ztit,ip_ebil_phy
+     e      , zero_v, zero_v, zero_v, zero_v, zero_v
+     e      , zero_v, zero_v, zero_v, ztsol
+     e      , d_h_vcol, d_qt, d_ec
+     s      , fs_bound, fq_bound )
       END IF 
 c
@@ -2845,7 +2937,7 @@
        IF (thermcep) THEN
         IF(zt2m(i).LT.RTT) then
-	 Lheat=RLSTT
-	ELSE
-	 Lheat=RLVTT
+         Lheat=RLSTT
+        ELSE
+         Lheat=RLVTT
         ENDIF
        ELSE
@@ -2853,5 +2945,5 @@
          Lheat=RLSTT
         ELSE
-	 Lheat=RLVTT
+         Lheat=RLVTT
         ENDIF
        ENDIF
@@ -2864,5 +2956,5 @@
          CALL VTe(VTphysiq)
          CALL VTb(VTinca)
-         calday = FLOAT(days_elapsed + 1) + jH_cur
+         calday = REAL(days_elapsed + 1) + jH_cur
 
          call chemtime(itap+itau_phy-1, date0, dtime)
@@ -2908,6 +3000,6 @@
      $                          cdragm,
      $                          pctsrf,
-     $				pdtphys,
-     $				itap)
+     $                          pdtphys,
+     $                            itap)
 
          CALL VTe(VTinca)
@@ -2964,5 +3056,5 @@
         call writefield_phy('v_seri',v_seri,llm)
         call writefield_phy('t_seri',t_seri,llm)
-	call writefield_phy('q_seri',q_seri,llm)
+       call writefield_phy('q_seri',q_seri,llm)
       endif
       
@@ -3020,5 +3112,5 @@
       itaprad = itaprad + 1
 
-      if (iflag_radia.eq.0) then
+      if (iflag_radia.eq.0 .and. prt_level.ge.9) then
       print *,'--------------------------------------------------'
       print *,'>>>> ATTENTION rayonnement desactive pour ce cas'
@@ -3043,5 +3135,5 @@
         call writefield_phy('v_seri',v_seri,llm)
         call writefield_phy('t_seri',t_seri,llm)
-	call writefield_phy('q_seri',q_seri,llm)
+        call writefield_phy('q_seri',q_seri,llm)
       endif
  
@@ -3124,5 +3216,5 @@
         call writefield_phy('v_seri',v_seri,llm)
         call writefield_phy('t_seri',t_seri,llm)
-	call writefield_phy('q_seri',q_seri,llm)
+        call writefield_phy('q_seri',q_seri,llm)
       endif
       
@@ -3188,5 +3280,5 @@
         call writefield_phy('v_seri',v_seri,llm)
         call writefield_phy('t_seri',t_seri,llm)
-	call writefield_phy('q_seri',q_seri,llm)
+        call writefield_phy('q_seri',q_seri,llm)
       endif
 
@@ -3223,4 +3315,9 @@
      e      , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay
      s      , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
+         call diagphy(airephy,ztit,ip_ebil_phy
+     e      , zero_v, zero_v, zero_v, zero_v, zero_v
+     e      , zero_v, zero_v, zero_v, ztsol
+     e      , d_h_vcol, d_qt, d_ec
+     s      , fs_bound, fq_bound )
       END IF 
 c
@@ -3292,5 +3389,6 @@
       IF (offline) THEN
 
-         print*,'Attention on met a 0 les thermiques pour phystoke'
+       IF (prt_level.ge.9)
+     $    print*,'Attention on met a 0 les thermiques pour phystoke'
 	 call phystokenc (
      I                   nlon,klev,pdtphys,rlon,rlat,
@@ -3400,4 +3498,5 @@
 c
 cIM initialisation 5eme fichier de sortie 
+cIM ajoute 5eme niveau 170310 BEG
       twriteSTD(:,:,5)=tlevSTD(:,:)
       qwriteSTD(:,:,5)=qlevSTD(:,:)
@@ -3484,5 +3583,5 @@
         call writefield_phy('v_seri',v_seri,llm)
         call writefield_phy('t_seri',t_seri,llm)
-	call writefield_phy('q_seri',q_seri,llm)
+        call writefield_phy('q_seri',q_seri,llm)
       endif
 
Index: /LMDZ4/trunk/libf/phylmd/phystokenc.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/phystokenc.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/phystokenc.F	(revision 1403)
@@ -13,4 +13,6 @@
       USE infotrac, ONLY : nqtot
       USE iophy
+      USE control_mod
+
       IMPLICIT none
 
@@ -24,5 +26,4 @@
 #include "tracstoke.h"
 #include "indicesol.h"
-#include "control.h"
 c======================================================================
 
Index: /LMDZ4/trunk/libf/phylmd/phytrac.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/phytrac.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/phytrac.F90	(revision 1403)
@@ -33,4 +33,6 @@
   USE traclmdz_mod
   USE tracinca_mod
+  USE control_mod
+
 
 
@@ -43,5 +45,4 @@
   INCLUDE "temps.h"
   INCLUDE "paramet.h"
-  INCLUDE "control.h"
   INCLUDE "thermcell.h"
 !==========================================================================
@@ -212,5 +213,6 @@
      SELECT CASE(type_trac)
      CASE('lmdz')
-        CALL traclmdz_init(pctsrf, ftsol, tr_seri, aerosol, lessivage)
+!IM ajout t_seri, pplay, sh    CALL traclmdz_init(pctsrf, ftsol, tr_seri, aerosol, lessivage)
+        CALL traclmdz_init(pctsrf, ftsol, tr_seri, t_seri, pplay, sh, aerosol, lessivage)
      CASE('inca')
         source(:,:)=0.
@@ -226,4 +228,10 @@
 !############################################ END INITIALIZATION #######
 
+  DO k=1,klev
+     DO i=1,klon
+        zmasse(i,k)=(paprs(i,k)-paprs(i,k+1))/rg
+     END DO
+  END DO
+
 !===============================================================================
 !    -- Do specific treatment according to chemestry model or local LMDZ tracers
@@ -234,10 +242,7 @@
      !    -- Traitement des traceurs avec traclmdz
      
-     CALL traclmdz(&
-          nstep,    pdtphys,      t_seri,           &
-          paprs,    pplay,        cdragh,  coefh,   &
-          yu1,      yv1,          ftsol,   pctsrf,  &
-          xlat,     couchelimite,                   &
-          tr_seri,  source,       solsym,  d_tr_cl)
+     CALL traclmdz(nstep, julien, gmtime, pdtphys, t_seri, paprs, pplay, &
+          cdragh,  coefh, yu1, yv1, ftsol, pctsrf, xlat, xlon, couchelimite, &
+          sh, tr_seri, source, solsym, d_tr_cl, zmasse)
      
   CASE('inca')
@@ -276,4 +281,7 @@
         END IF
 
+!IM ajout traceurs RR 
+!      print*,'phytrac it,nseuil=',it,nseuil
+       IF (it.lt.nseuil) THEN
         DO k = 1, klev
            DO i = 1, klon        
@@ -281,4 +289,5 @@
            END DO
         END DO
+       END IF !(it.lt.nseuil) then
 
         CALL minmaxqfi(tr_seri(:,:,it),0.,1.e33,'convection it = '//solsym(it))
@@ -290,10 +299,4 @@
 !    -- Calcul de l'effet des thermiques --
 !======================================================================
-
-  DO k=1,klev
-     DO i=1,klon
-        zmasse(i,k)=(paprs(i,k)-paprs(i,k+1))/rg
-     END DO
-  END DO
 
   DO it=1,nbtr
Index: /LMDZ4/trunk/libf/phylmd/press_coefoz_m.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/press_coefoz_m.F90	(revision 1403)
+++ /LMDZ4/trunk/libf/phylmd/press_coefoz_m.F90	(revision 1403)
@@ -0,0 +1,72 @@
+! $Id$
+module press_coefoz_m
+
+  implicit none
+
+  real, pointer, save:: plev(:)
+  ! (pressure level of Mobidic input data, converted to Pa, in strictly
+  ! ascending order)
+
+  real, allocatable, save:: press_in_edg(:)
+  ! (edges of pressure intervals for Mobidic input data, in Pa, in strictly
+  ! ascending order)
+
+contains
+
+  subroutine press_coefoz
+
+    ! This procedure is called once per "gcm" run.
+    ! A single thread of the root process reads the pressure levels
+    ! from "coefoz_LMDZ.nc" and broadcasts them to the other processes.
+
+    ! We assume that, in "coefoz_LMDZ.nc", the pressure levels are in hPa
+    ! and in strictly ascending order.
+
+    use netcdf95, only: nf95_open, nf95_close, nf95_gw_var, nf95_inq_varid
+    use netcdf, only: nf90_nowrite
+
+    use mod_phys_lmdz_mpi_data, only: is_mpi_root
+    use mod_phys_lmdz_mpi_transfert, only: bcast_mpi ! broadcast
+
+    ! Variables local to the procedure:
+    integer ncid, varid ! for NetCDF
+    integer n_plev ! number of pressure levels in the input data
+    integer k
+
+    !---------------------------------------
+
+    !$omp single
+    print *, "Call sequence information: press_coefoz"
+
+    if (is_mpi_root) then
+       call nf95_open("coefoz_LMDZ.nc", nf90_nowrite, ncid)
+
+       call nf95_inq_varid(ncid, "plev", varid)
+       call nf95_gw_var(ncid, varid, plev)
+       ! Convert from hPa to Pa because "paprs" and "pplay" are in Pa:
+       plev = plev * 100.
+       n_plev = size(plev)
+
+       call nf95_close(ncid)
+    end if
+
+    call bcast_mpi(n_plev)
+    if (.not. is_mpi_root) allocate(plev(n_plev))
+    call bcast_mpi(plev)
+    
+    ! Compute edges of pressure intervals:
+    allocate(press_in_edg(n_plev + 1))
+    if (is_mpi_root) then
+       press_in_edg(1) = 0.
+       ! We choose edges halfway in logarithm:
+       forall (k = 2:n_plev) press_in_edg(k) = sqrt(plev(k - 1) * plev(k))
+       press_in_edg(n_plev + 1) = huge(0.)
+       ! (infinity, but any value guaranteed to be greater than the
+       ! surface pressure would do)
+    end if
+    call bcast_mpi(press_in_edg)
+    !$omp end single
+
+  end subroutine press_coefoz
+
+end module press_coefoz_m
Index: /LMDZ4/trunk/libf/phylmd/printflag.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/printflag.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/printflag.F	(revision 1403)
@@ -85,5 +85,5 @@
        IF( INT( tabcntr0( 6 ) ) .NE. nbapp_rad  )   THEN
         PRINT 21,  INT(tabcntr0(6)), nbapp_rad
-        radpas0  = NINT( 86400./tabcntr0(1)/INT( tabcntr0(6) ) )
+!        radpas0  = NINT( 86400./tabcntr0(1)/INT( tabcntr0(6) ) )
         PRINT 100
         PRINT 22, radpas0, radpas
Index: /LMDZ4/trunk/libf/phylmd/read_pstoke.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/read_pstoke.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/read_pstoke.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 c
@@ -18,6 +18,8 @@
 C******************************************************************************
 
-	use netcdf
-       USE dimphy
+      use netcdf
+      USE dimphy
+      USE control_mod
+
        IMPLICIT NONE
 
@@ -33,5 +35,4 @@
 #include "serre.h"
 #include "indicesol.h"
-#include "control.h"
 cccc#include "dimphy.h"
 	
Index: /LMDZ4/trunk/libf/phylmd/read_pstoke0.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/read_pstoke0.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/read_pstoke0.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 c
@@ -19,4 +19,6 @@
 	use netcdf
        USE dimphy
+       USE control_mod
+
        IMPLICIT NONE
 
@@ -32,5 +34,4 @@
 #include "serre.h"
 #include "indicesol.h"
-#include "control.h"
 cccc#include "dimphy.h"
 	  
Index: /LMDZ4/trunk/libf/phylmd/readaerosol.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/readaerosol.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/readaerosol.F90	(revision 1403)
@@ -137,5 +137,5 @@
                  DO i = 1, klon
                     pt_out(i,k,it) = &
-                         pt_out(i,k,it) - FLOAT(iyr_in-iyr1)/FLOAT(iyr2-iyr1) * &
+                         pt_out(i,k,it) - REAL(iyr_in-iyr1)/REAL(iyr2-iyr1) * &
                          (pt_out(i,k,it) - pt_2(i,k,it))
                  END DO
@@ -144,9 +144,9 @@
               DO i = 1, klon
                  psurf(i,it) = &
-                      psurf(i,it) - FLOAT(iyr_in-iyr1)/FLOAT(iyr2-iyr1) * &
+                      psurf(i,it) - REAL(iyr_in-iyr1)/REAL(iyr2-iyr1) * &
                       (psurf(i,it) - psurf2(i,it))
 
                  load(i,it) = &
-                      load(i,it) - FLOAT(iyr_in-iyr1)/FLOAT(iyr2-iyr1) * &
+                      load(i,it) - REAL(iyr_in-iyr1)/REAL(iyr2-iyr1) * &
                       (load(i,it) - load2(i,it))
               END DO
@@ -514,6 +514,6 @@
                 spole = spole + varyear(i,jjm+1,k,imth)
              END DO
-             npole = npole/FLOAT(iim)
-             spole = spole/FLOAT(iim)
+             npole = npole/REAL(iim)
+             spole = spole/REAL(iim)
              varyear(:,1,    k,imth) = npole
              varyear(:,jjm+1,k,imth) = spole
Index: /LMDZ4/trunk/libf/phylmd/readaerosol_interp.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/readaerosol_interp.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/readaerosol_interp.F90	(revision 1403)
@@ -127,8 +127,8 @@
   IF(mpi_rank == 0 .AND. debug)then
      ! 0.02 is about 0.5/24, namly less than half an hour
-     OLDNEWDAY = (r_day-FLOAT(iday) < 0.02)
+     OLDNEWDAY = (r_day-REAL(iday) < 0.02)
      ! Once per day, update aerosol fields
      lmt_pas = NINT(86400./pdtphys)
-     PRINT*,'r_day-FLOAT(iday) =',r_day-FLOAT(iday) 
+     PRINT*,'r_day-REAL(iday) =',r_day-REAL(iday) 
      PRINT*,'itap =',itap
      PRINT*,'pdtphys =',pdtphys
@@ -234,10 +234,10 @@
 !
      DO i = 2, 13
-       month_len(i) = float(ioget_mon_len(year_cur, i-1))
+       month_len(i) = REAL(ioget_mon_len(year_cur, i-1))
        CALL ymds2ju(year_cur, i-1, 1, 0.0, month_start(i))
      ENDDO
-     month_len(1) = float(ioget_mon_len(year_cur-1, 12))
+     month_len(1) = REAL(ioget_mon_len(year_cur-1, 12))
      CALL ymds2ju(year_cur-1, 12, 1, 0.0, month_start(1))
-     month_len(14) = float(ioget_mon_len(year_cur+1, 1))
+     month_len(14) = REAL(ioget_mon_len(year_cur+1, 1))
      CALL ymds2ju(year_cur+1, 1, 1, 0.0, month_start(14))
      month_mid(:) = month_start (:) + month_len(:)/2.
